#!/usr/local/bin/perl -w
#
# Seek in an mSQL DB of students, criteria set by promotion.
#
$version="4.50b";
#
# (c) 1997 Emmanuel PIERRE
#	   epierre@hp1.esiea.fr
#	   http://www.cybermax.fr/vip/pierre
#
# Developed at/by:
#	   Ecole Suprieure d'Informatique-Electronique-Automatique
#	   a project of the School Web Server
#
#	   http://www.esiea.fr
#	   
#
$prog="GenIDXEleve.pl";
@date = gmtime(time);
$an = $date[5];
if (($an>96)&&($an<=99)) {  $an = "19".$an; } else { $an = "20".$an }
if ($ARGV[0] ne "-1") { $an += $ARGV[0]; }

# Some default variables:

# $host="host-with-msql-server"
$host = "";
$dbase="esiea";
$table="eleves";

# NOTE:
# Leave $host undefined if you are on the same machine, will
# ensure that /dev/msql is used rather than the slow
# tcp/ip connection.
#


# # # # # # #
#
# Redirection sortie standard
#
open(STDOUT,"> $ARGV[1]")|| die "Err: $!";

# Announce html coming up
#
#print "Content-type: text/html\n\n";

# ensure we have the PerlMsql adaptor switched on..
#
&Exit("Could not Initialize/find the PerlMsql adaptor $@")
	if (eval("use Msql"));


# Ensure the connection (this can be done more effectively,
# but this illustrates things better....
#
&Exit("Could not connect to mSQL server")
	unless ($dbh=Connect Msql $host );

# Find out what is there...
#
&Exit("Could not get a list of dbases ")
        unless( @dbase = $dbh -> ListDBs);

# Select a DB
#
&Exit("Could not select mSQL dbase '$dbase'")
        unless (Msql::SelectDB($dbh,$dbase));

# Now get down to the real work, and get into the table
#
&Exit("Could not get a list of Fields for $table")
        unless ($sth = Msql::ListFields( $dbh,$table ));

# if there are any fields
#
if (!($sth->numfields)) {
        # barf seriously...
        #
        &Exit("No fields in the table: $table");
        };



&Exit("Could not select mSQL dbase '$dbase'")
        unless (Msql::SelectDB($dbh,$dbase));

# arguments of course...
#
if ($ARGV[0] eq "-1") {
	$qstring="select nom,prenom,login,page,site from $table where annee<$an order by nom,prenom"; 
} else {
	$qstring="select nom,prenom,login,page,site from $table where annee=$an order by nom,prenom";
}

&Exit("Could not do query '$qstring'")
	unless ($sth = Msql::Query( $dbh ,$qstring ));


# And output the results...
#
if ($sth->numrows) {
	# we have results, so...	
	#

	# null a results/row counter
	#
	$i=0;

	# create a header for the table
	#
	$results ="<!-- Generated by $prog v$version (C) 1997 Emmanuel PIERRE <epierre\@mail.esiea.fr>-->\n";
	$results .="<CENTER><table cellpadding=5 cellspacing=3 border=1 COLSPEC=\"L35 L20 L20 L5\" width=100%>\n";
	$results .="<tr><th>Nom</th><th>Prnom</th><th>Email</th><th>Site</th></tr>\n";
	# and loop over each of the rows in the results
	#
	$letter = "";	
	$oldletter = "";

	while (@row=FetchRow $sth ) {
		$oldletter=$letter;
		$_=@row->[0];
		($letter)=(/(.).*/);
		if ($letter ne $oldletter) {
			$_ = $letter;
			tr/a-z/A-Z/;
			$lettre = $_;
			$results .="</table></CENTER><BR><BR>\n";
			$results .="<FONT SIZE=20>$lettre</FONT><BR><BR>\n" ;
			$results .="<CENTER><table cellpadding=5 cellspacing=3 border=1 COLSPEC=\"L35 L20 L20 L5\" width=100%>\n";
		}

		# and count them toooo...
		#
		$i++;
		$results .="\t<tr>";

		# loop over the fields in each row
		#for $r (@row) {
		#	$results .= "<td>$r</td>";
		#	};
		 if (@row->[3] ne '') { 
			$nom=@row->[0];
                        $nom =~ tr /a-z/A-Z/;
                        $nom =~ tr /#/'/;
			$results .= "<td><A HREF=\"@row->[3]\">$nom</A></td>";
		 }
                else {
			$nom=@row->[0];
			$nom =~ tr /a-z/A-Z/;
			$nom =~ tr /#/'/;
			$results .= "<td>$nom</td>";
		}

		$results .= "<td>@row->[1]</td>";
		if (@row->[2] =~ /\@/) {
		$results .= "<td><A HREF=\"mailto:@row->[2]\">@row->[2]</A></td>"; } else {
			if (@row->[4] eq "Paris") {
		$results .= "<td><A HREF=\"mailto:@row->[2]\@mail.esiea.fr\">@row->[2]\@mail.esiea.fr</A></td>"; }
			if (@row->[4] eq "Laval") {
		$results .= "<td><A HREF=\"mailto:@row->[1].$nom\@mail.esiea-ouest.fr\">@row->[1].$nom\@mail.esiea-ouest.fr</A></td>"; }
	  }
	
		$results .= "<td>@row->[4]</td>";
		$results .="</tr>\n";
		};

	$results .="</table></CENTER>";

	# be suspicious, and check if we got all we
	# wher promised ?!
	#
	&Exit("Not all values received")
		if ($i != $sth->numrows);
	
	} else {

	# and if there is nothing, be nice...
	#
	$results .="<b>NO</b> results... :-(<BR>\n";
	};

# Right, ready ?! we can now output it as we are sure that we
# will not have any more nasty errors... at least not errors
# we want to tell the user about..
#
print qq|
$results
|;

close(STDOUT);

exit;


# Terminating error message, bit primitive really
#
sub Exit { 
local ($errmsg)=@_;
print qq|
<html>
<head><title>mSQL; Failure</title></head><body>
<center><h1><hr>mSQL Script Failure</h1>
</center>
<h2>$errmsg</h2>
<h3>$@ </h3>
<hr>
<p>
</body>
</html>
|;
exit;
};



