#!/usr/local/bin/perl
#
# Small example of how to query and output
# the results of an mSQL rq. Requires the mSQL/Perl
# adaptor.
#
$version="1.00b";
#
# (c) 1997 Emmanuel PIERRE
#	   epierre@hp1.esiea.fr
#	   http://www.cybermax.fr/vip/pierre
#
# Developed at/by:
#	   Ecole Suprieure d'Informatique-Electronique-Automatique
#	   a project of the School Web Server
#
#	   http://www.esiea.fr
#	   
#
$prog="liste";

# Some default vriables:

# $host="host-with-msql-server"

$dbase="esiea";
$table="eleves";

local ($tab);

# # # # # 
#
#	Open Database
#

# ensure we have the PerlMsql adaptor switched on..
#
&Exit("Could not Initialize/find the PerlMsql adaptor $@")
        if (eval("use Msql"));


# Ensure the connection (this can be done more effectively,
# but this illustrates things better....
#
&Exit("Could not connect to mSQL server")
        unless ($dbh=Connect Msql $host );

# Find out what is there...
#
&Exit("Could not get a list of dbases ")
        unless( @dbase = $dbh -> ListDBs);

# Select a DB
#
&Exit("Could not select mSQL dbase '$dbase'")
        unless (Msql::SelectDB($dbh,$dbase));
# Now get down to the real work, and get into the table
#
&Exit("Could not get a list of Fields for $table")
        unless ($sth = Msql::ListFields( $dbh,$table ));

# if there are any fields
#
if ($sth->numfields) {

        # get yourself a list

        #
        @fields=(@{$sth->name});
        } else {

        # if not barf seriously...
        #
        &Exit("No fields in the table: $table");
        };
&Exit("Could not select mSQL dbase '$dbase'")
        unless (Msql::SelectDB($dbh,$dbase));

# arguments of course...
#

#$qstring="create table eleves (nom char(60) not null, prenom char(60) not null, login char(80), annee int, site char(10), tpfh char(80), page char(100), cvfr char(100),cven char(100))";
#&Exit("Could not do query '$qstring'")
#unless ($sth = Msql::Query( $dbh ,$qstring ));

# # # # #
#
#	Treatment
#

($fic = open(TXT,"cat liste.txt |")) or die "ERR: $!";
(kill 0,$fic) or die "cat invocation failed";

while ($lec=<TXT>) {
	
	chomp($lec);

	($login, $id, $name, $firstname, $group) = ($lec =~ m/([a-z0-9#]+)\s+(\d+)\s+([A-Z'\- ]+)\s+([A-Za-z'\- ]+)\s+([a-zA-Z0-9]*).*/s);

	#if ((($login =~ /(\S).*/) ne "#")&&($login ne "")) {


	($res) = ($login =~ m/(.?).*/s);
	if (($res ne "#")&&($login ne "")) {
		$name =~ tr/A-Z/a-z/;
		$name =~ tr/'/#/;
		$firstname =~ tr/A-Z/a-z/;
		($typesite,$annee) = ($group =~ /(.+)([0-9][0-9]).*/);
		if ($typesite eq "a") {$site="Paris";} else {$SITE="Laval"};
		$annee++;
		if ($annee > 99) { $annee = $annee - 100; $annee="0".$annee;}
		if ($annee ne "" ) {
			if ($annee > 90) {
				$qstring = "insert into eleves values ('$name','$firstname','$login',19$annee,'$site','','','','')";
				print "$qstring\n";
				&Exit("Could not do query '$qstring'")
				unless ($sth = Msql::Query( $dbh ,$qstring ));
			} else {
				$qstring = "insert into eleves values ('$name','$firstname','$login',20$annee,'$site','','','','')";
				print "$qstring\n";
				&Exit("Could not do query '$qstring'")
				unless ($sth = Msql::Query( $dbh ,$qstring ));
			}
		}
	}
	else {
		print "--> $lec\n";
	}

}

close(TXT);

exit;
# Terminating error message, bit primitive really
#
sub Exit {
local ($errmsg)=@_;
print qq|
mSQL; Failure
$errmsg
$@ $Msql::db_errstr
|;
$qstring="drop table eleves";
&Exit("Could not do query '$qstring'")
unless ($sth = Msql::Query( $dbh ,$qstring ));
exit;
};

